Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/phys_local_var_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/phys_local_var_mod.F90	(revision 5095)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/phys_local_var_mod.F90	(revision 5098)
@@ -1009,32 +1010,32 @@
       ALLOCATE(d_deltaxt_ajs_cv(ntraciso,klon, klev))
 #endif
-!!         End of wake variables
-!!
-      ALLOCATE(bils(klon))
-      ALLOCATE(cdragm(klon), cdragh(klon), cldh(klon), cldl(klon))
-      ALLOCATE(cldm(klon), cldq(klon), cldt(klon), qsat2m(klon))
-      ALLOCATE(JrNt(klon))
-      ALLOCATE(dthmin(klon), evap(klon), snowerosion(klon), fder(klon), plcl(klon), plfc(klon))
-      ALLOCATE(prw(klon), prlw(klon), prsw(klon), prbsw(klon), water_budget(klon), zustar(klon), zu10m(klon), zv10m(klon), rh2m(klon))
-      ALLOCATE(s_lcl(klon))
-      ALLOCATE(s_pblh(klon), s_pblt(klon), s_therm(klon))
-!
-!nrlmd+jyg<
-      ALLOCATE(s_pblh_x(klon), s_pblh_w(klon))
-      ALLOCATE(s_lcl_x(klon), s_lcl_w(klon))
-!>nrlmd+jyg
-!
-      ALLOCATE(slab_wfbils(klon), tpot(klon), tpote(klon), ue(klon))
-      ALLOCATE(uq(klon), ve(klon), vq(klon), zxffonte(klon))
-      ALLOCATE(uwat(klon), vwat(klon))
-      ALLOCATE(zxfqcalving(klon), zxfluxlat(klon))
-      ALLOCATE(zxtsol(klon), snow_lsc(klon), zxfqfonte(klon), zxqsurf(klon))
-      ALLOCATE(zxrunofflic(klon))
-      ALLOCATE(zxustartlic(klon), zxrhoslic(klon), zxqsaltlic(klon))
-      zxustartlic(:)=0. ; zxrhoslic(:)=0. ; zxqsaltlic(:)=0.
-      ALLOCATE(rain_lsc(klon))
-      ALLOCATE(rain_num(klon))
-      ALLOCATE(qlth(klon,klev), qith(klon,klev), qsith(klon,klev), wiceth(klon,klev))
-      !
+    !!         End of wake variables
+    !!
+    ALLOCATE(bils(klon))
+    ALLOCATE(cdragm(klon), cdragh(klon), cldh(klon), cldl(klon))
+    ALLOCATE(cldm(klon), cldq(klon), cldt(klon), qsat2m(klon))
+    ALLOCATE(JrNt(klon))
+    ALLOCATE(dthmin(klon), evap(klon), snowerosion(klon), fder(klon), plcl(klon), plfc(klon))
+    ALLOCATE(prw(klon), prlw(klon), prsw(klon), prbsw(klon), water_budget(klon), zustar(klon), zu10m(klon), zv10m(klon), rh2m(klon))
+    ALLOCATE(s_lcl(klon))
+    ALLOCATE(s_pblh(klon), s_pblt(klon), s_therm(klon))
+    !
+    !nrlmd+jyg<
+    ALLOCATE(s_pblh_x(klon), s_pblh_w(klon))
+    ALLOCATE(s_lcl_x(klon), s_lcl_w(klon))
+    !>nrlmd+jyg
+    !
+    ALLOCATE(slab_wfbils(klon), tpot(klon), tpote(klon), ue(klon))
+    ALLOCATE(uq(klon), ve(klon), vq(klon), zxffonte(klon))
+    ALLOCATE(uwat(klon), vwat(klon))
+    ALLOCATE(zxfqcalving(klon), zxfluxlat(klon))
+    ALLOCATE(zxtsol(klon), snow_lsc(klon), zxfqfonte(klon), zxqsurf(klon))
+    ALLOCATE(zxrunofflic(klon))
+    ALLOCATE(zxustartlic(klon), zxrhoslic(klon), zxqsaltlic(klon))
+    zxustartlic(:) = 0. ; zxrhoslic(:) = 0. ; zxqsaltlic(:) = 0.
+    ALLOCATE(rain_lsc(klon))
+    ALLOCATE(rain_num(klon))
+    ALLOCATE(qlth(klon, klev), qith(klon, klev), qsith(klon, klev), wiceth(klon, klev))
+    !
 #ifdef ISO
       ALLOCATE(xtevap(ntraciso,klon))
@@ -1049,81 +1050,83 @@
       runoff_diag(:)=0. ; xtrunoff_diag(:,:)=0. ! because variables are only given values on knon grid points
 #endif
-!
-      ALLOCATE(sens_x(klon), sens_w(klon))
-      ALLOCATE(zxfluxlat_x(klon), zxfluxlat_w(klon))
-      ALLOCATE(delta_qsurf(klon))
-!jyg<
-!!      ALLOCATE(t_x(klon,klev), t_w(klon,klev))
-!!      ALLOCATE(q_x(klon,klev), q_w(klon,klev))
-!>jyg
-      ALLOCATE(dtvdf_x(klon,klev), dtvdf_w(klon,klev))
-      dtvdf_x = 0 ; dtvdf_w=0 ;   !ym missing init
-      ALLOCATE(dqvdf_x(klon,klev), dqvdf_w(klon,klev))
-      dqvdf_x = 0 ; dqvdf_w=0 ;   !ym missing init
-      ALLOCATE(pbl_tke_input(klon,klev+1,nbsrf))
-      ALLOCATE(t_therm(klon,klev), q_therm(klon,klev),u_therm(klon,klev), v_therm(klon,klev))
-      ALLOCATE(cdragh_x(klon), cdragh_w(klon))
-      ALLOCATE(cdragm_x(klon), cdragm_w(klon))
-      ALLOCATE(kh(klon), kh_x(klon), kh_w(klon))
+    !
+    ALLOCATE(sens_x(klon), sens_w(klon))
+    ALLOCATE(zxfluxlat_x(klon), zxfluxlat_w(klon))
+    ALLOCATE(delta_qsurf(klon))
+    !jyg<
+    !!      ALLOCATE(t_x(klon,klev), t_w(klon,klev))
+    !!      ALLOCATE(q_x(klon,klev), q_w(klon,klev))
+    !>jyg
+    ALLOCATE(dtvdf_x(klon, klev), dtvdf_w(klon, klev))
+    dtvdf_x = 0 ; dtvdf_w = 0 ;
+    !ym missing init
+    ALLOCATE(dqvdf_x(klon, klev), dqvdf_w(klon, klev))
+    dqvdf_x = 0 ; dqvdf_w = 0 ;
+    !ym missing init
+    ALLOCATE(pbl_tke_input(klon, klev + 1, nbsrf))
+    ALLOCATE(t_therm(klon, klev), q_therm(klon, klev), u_therm(klon, klev), v_therm(klon, klev))
+    ALLOCATE(cdragh_x(klon), cdragh_w(klon))
+    ALLOCATE(cdragm_x(klon), cdragm_w(klon))
+    ALLOCATE(kh(klon), kh_x(klon), kh_w(klon))
 #ifdef ISO
       ALLOCATE(dxtvdf_x(ntraciso,klon,klev), dxtvdf_w(ntraciso,klon,klev))
       ALLOCATE(xt_therm(ntraciso,klon,klev))
 #endif
-!
-      ALLOCATE(ptconv(klon,klev))
-      ALLOCATE(ratqsc(klon,klev))
-!
-      ALLOCATE(wbeff(klon), convoccur(klon), zmax_th(klon))
-      ALLOCATE(zq2m(klon), zt2m(klon), weak_inversion(klon))
-      ALLOCATE(zt2m_min_mon(klon), zt2m_max_mon(klon))
-      ALLOCATE(t2m_min_mon(klon), t2m_max_mon(klon))
-      ALLOCATE(sens(klon), flwp(klon), fiwp(klon))
-      ALLOCATE(alp_bl_conv(klon), alp_bl_det(klon))
-      alp_bl_conv(:)=0 ;  alp_bl_det(:)=0
-      ALLOCATE(alp_bl_fluct_m(klon), alp_bl_fluct_tke(klon))
-      alp_bl_fluct_m(:)=0 ; alp_bl_fluct_tke(:)= 0.
-      ALLOCATE(alp_bl_stat(klon), n2(klon), s2(klon), strig(klon), zcong(klon), zlcl_th(klon))
-      alp_bl_stat(:)=0
-      ALLOCATE(proba_notrig(klon), random_notrig(klon))
-
-      ALLOCATE(dnwd0(klon, klev))
-!      ALLOCATE(upwd(klon, klev), omega(klon, klev), coefh(klon, klev))
-      ALLOCATE(omega(klon, klev))
-      ALLOCATE(epmax_diag(klon)) ! epmax_cape
-!      ALLOCATE(coefm(klon, klev), lambda_th(klon, klev), cldemi(klon, klev))
-      ALLOCATE(lambda_th(klon, klev), cldemi(klon, klev))
-      ALLOCATE(cldfra(klon, klev), cldtau(klon, klev), fiwc(klon, klev))
-      ALLOCATE(fl(klon, klev), re(klon, klev), flwc(klon, klev))
-      ALLOCATE(ref_liq(klon, klev), ref_ice(klon, klev), theta(klon, klev))
-      ALLOCATE(ref_liq_pi(klon, klev), ref_ice_pi(klon, klev))
-      ALLOCATE(zphi(klon, klev), zx_rh(klon, klev), zx_rhl(klon,klev), zx_rhi(klon,klev))
-      zx_rhl(:,:)=0.; zx_rhi(:,:)=0. ! because not always defined
-      ALLOCATE(pmfd(klon, klev), pmfu(klon, klev))
-
-      ALLOCATE(t2m(klon, nbsrf), fluxlat(klon, nbsrf))
-      ALLOCATE(fsollw(klon, nbsrf))
-      ALLOCATE(fsolsw(klon, nbsrf), wfbils(klon, nbsrf))
-      ALLOCATE(wfevap(klon, nbsrf))
-      ALLOCATE(evap_pot(klon, nbsrf))
-! FC 
-      ALLOCATE(zxfluxq(klon,klev),zxfluxt(klon,klev))
-!
-!
-!  Deep convective variables used in phytrac
-      ALLOCATE(pmflxr(klon, klev+1), pmflxs(klon, klev+1))
-      ALLOCATE(wdtrainA(klon,klev),wdtrainS(klon,klev),wdtrainM(klon,klev))
-      ALLOCATE(dnwd(klon, klev), upwd(klon, klev))
-      ALLOCATE(ep(klon,klev))                          ! epmax_cape
-      ALLOCATE(da(klon,klev), mp(klon,klev))
-      ALLOCATE(phi(klon,klev,klev))
-      ALLOCATE(wght_cvfd(klon,klev))
-      ALLOCATE(phi2(klon,klev,klev))
-      ALLOCATE(d1a(klon,klev), dam(klon,klev))
-      ALLOCATE(ev(klon,klev))
-      ALLOCATE(elij(klon,klev,klev))
-      ALLOCATE(qtaa(klon,klev))
-      ALLOCATE(clw(klon,klev))
-      ALLOCATE(epmlmMm(klon,klev,klev), eplaMm(klon,klev))
-      ALLOCATE(sij(klon,klev,klev))
+    !
+    ALLOCATE(ptconv(klon, klev))
+    ALLOCATE(ratqsc(klon, klev))
+    !
+    ALLOCATE(wbeff(klon), convoccur(klon), zmax_th(klon))
+    ALLOCATE(zq2m(klon), zt2m(klon), weak_inversion(klon))
+    ALLOCATE(zt2m_min_mon(klon), zt2m_max_mon(klon))
+    ALLOCATE(t2m_min_mon(klon), t2m_max_mon(klon))
+    ALLOCATE(sens(klon), flwp(klon), fiwp(klon))
+    ALLOCATE(alp_bl_conv(klon), alp_bl_det(klon))
+    alp_bl_conv(:) = 0 ;  alp_bl_det(:) = 0
+    ALLOCATE(alp_bl_fluct_m(klon), alp_bl_fluct_tke(klon))
+    alp_bl_fluct_m(:) = 0 ; alp_bl_fluct_tke(:) = 0.
+    ALLOCATE(alp_bl_stat(klon), n2(klon), s2(klon), strig(klon), zcong(klon), zlcl_th(klon))
+    alp_bl_stat(:) = 0
+    ALLOCATE(proba_notrig(klon), random_notrig(klon))
+
+    ALLOCATE(dnwd0(klon, klev))
+    !      ALLOCATE(upwd(klon, klev), omega(klon, klev), coefh(klon, klev))
+    ALLOCATE(omega(klon, klev))
+    ALLOCATE(epmax_diag(klon)) ! epmax_cape
+    !      ALLOCATE(coefm(klon, klev), lambda_th(klon, klev), cldemi(klon, klev))
+    ALLOCATE(lambda_th(klon, klev), cldemi(klon, klev))
+    ALLOCATE(cldfra(klon, klev), cldtau(klon, klev), fiwc(klon, klev))
+    ALLOCATE(fl(klon, klev), re(klon, klev), flwc(klon, klev))
+    ALLOCATE(ref_liq(klon, klev), ref_ice(klon, klev), theta(klon, klev))
+    ALLOCATE(ref_liq_pi(klon, klev), ref_ice_pi(klon, klev))
+    ALLOCATE(zphi(klon, klev), zx_rh(klon, klev), zx_rhl(klon, klev), zx_rhi(klon, klev))
+    zx_rhl(:, :) = 0.; zx_rhi(:, :) = 0. ! because not always defined
+    ALLOCATE(pmfd(klon, klev), pmfu(klon, klev))
+
+    ALLOCATE(t2m(klon, nbsrf), fluxlat(klon, nbsrf))
+    ALLOCATE(fsollw(klon, nbsrf))
+    ALLOCATE(fsolsw(klon, nbsrf), wfbils(klon, nbsrf))
+    ALLOCATE(wfevap(klon, nbsrf))
+    ALLOCATE(evap_pot(klon, nbsrf))
+    ! FC
+    ALLOCATE(zxfluxq(klon, klev), zxfluxt(klon, klev))
+    !
+    !
+    !  Deep convective variables used in phytrac
+    ALLOCATE(pmflxr(klon, klev + 1), pmflxs(klon, klev + 1))
+    ALLOCATE(wdtrainA(klon, klev), wdtrainS(klon, klev), wdtrainM(klon, klev))
+    ALLOCATE(dnwd(klon, klev), upwd(klon, klev))
+    ALLOCATE(ep(klon, klev))                          ! epmax_cape
+    ALLOCATE(da(klon, klev), mp(klon, klev))
+    ALLOCATE(phi(klon, klev, klev))
+    ALLOCATE(wght_cvfd(klon, klev))
+    ALLOCATE(phi2(klon, klev, klev))
+    ALLOCATE(d1a(klon, klev), dam(klon, klev))
+    ALLOCATE(ev(klon, klev))
+    ALLOCATE(elij(klon, klev, klev))
+    ALLOCATE(qtaa(klon, klev))
+    ALLOCATE(clw(klon, klev))
+    ALLOCATE(epmlmMm(klon, klev, klev), eplaMm(klon, klev))
+    ALLOCATE(sij(klon, klev, klev))
 #ifdef ISO
       ALLOCATE(xtwdtrainA(ntraciso,klon,klev))
@@ -1150,30 +1153,30 @@
 #endif
 
-      ALLOCATE(prfl(klon, klev+1))
-      ALLOCATE(psfl(klon, klev+1), fraca(klon, klev+1), Vprecip(klon, klev+1))
-      ALLOCATE(bsfl(klon,klev+1))
-      ALLOCATE(zw2(klon, klev+1))
-
-      ALLOCATE(fluxu(klon, klev, nbsrf), fluxv(klon, klev, nbsrf))
-      ALLOCATE(fluxt(klon, klev, nbsrf))
-
-      ALLOCATE(uwriteSTD(klon,nlevSTD,nfiles), vwriteSTD(klon,nlevSTD,nfiles))
-      ALLOCATE(wwriteSTD(klon,nlevSTD,nfiles), phiwriteSTD(klon,nlevSTD,nfiles))
-      ALLOCATE(qwriteSTD(klon,nlevSTD,nfiles), twriteSTD(klon,nlevSTD,nfiles))
-      ALLOCATE(rhwriteSTD(klon,nlevSTD,nfiles))
-
-! ug et d'autres encore:
-      ALLOCATE(beta_prec(klon,klev))
-      ALLOCATE(rneb(klon,klev),rnebjn(klon,klev),rneblsvol(klon,klev))
-      ALLOCATE(pfraclr(klon,klev),pfracld(klon,klev))
-      pfraclr(:,:)=0. ; pfracld(:,:)=0. ! because not always defined
-      ALLOCATE(cldfraliq(klon,klev))
-      ALLOCATE(sigma2_icefracturb(klon,klev))
-      ALLOCATE(mean_icefracturb(klon,klev))
-      ALLOCATE(distcltop(klon,klev))
-      ALLOCATE(temp_cltop(klon,klev))
-
-      ALLOCATE (zxsnow(klon),snowhgt(klon),qsnow(klon),to_ice(klon))
-      ALLOCATE (sissnow(klon),runoff(klon),albsol3_lic(klon))
+    ALLOCATE(prfl(klon, klev + 1))
+    ALLOCATE(psfl(klon, klev + 1), fraca(klon, klev + 1), Vprecip(klon, klev + 1))
+    ALLOCATE(bsfl(klon, klev + 1))
+    ALLOCATE(zw2(klon, klev + 1))
+
+    ALLOCATE(fluxu(klon, klev, nbsrf), fluxv(klon, klev, nbsrf))
+    ALLOCATE(fluxt(klon, klev, nbsrf))
+
+    ALLOCATE(uwriteSTD(klon, nlevSTD, nfiles), vwriteSTD(klon, nlevSTD, nfiles))
+    ALLOCATE(wwriteSTD(klon, nlevSTD, nfiles), phiwriteSTD(klon, nlevSTD, nfiles))
+    ALLOCATE(qwriteSTD(klon, nlevSTD, nfiles), twriteSTD(klon, nlevSTD, nfiles))
+    ALLOCATE(rhwriteSTD(klon, nlevSTD, nfiles))
+
+    ! ug et d'autres encore:
+    ALLOCATE(beta_prec(klon, klev))
+    ALLOCATE(rneb(klon, klev), rnebjn(klon, klev), rneblsvol(klon, klev))
+    ALLOCATE(pfraclr(klon, klev), pfracld(klon, klev))
+    pfraclr(:, :) = 0. ; pfracld(:, :) = 0. ! because not always defined
+    ALLOCATE(cldfraliq(klon, klev))
+    ALLOCATE(sigma2_icefracturb(klon, klev))
+    ALLOCATE(mean_icefracturb(klon, klev))
+    ALLOCATE(distcltop(klon, klev))
+    ALLOCATE(temp_cltop(klon, klev))
+
+    ALLOCATE (zxsnow(klon), snowhgt(klon), qsnow(klon), to_ice(klon))
+    ALLOCATE (sissnow(klon), runoff(klon), albsol3_lic(klon))
 #ifdef ISO
       ALLOCATE (zxxtsnow(niso,klon))
@@ -1182,49 +1185,49 @@
 #endif
 
-      ALLOCATE (p_tropopause(klon))
-      ALLOCATE (z_tropopause(klon))
-      ALLOCATE (t_tropopause(klon))
-
-      ALLOCATE(zn2mout(klon,6))
-
-! Supersaturation
-      ALLOCATE(rneb_seri(klon,klev))
-      ALLOCATE(d_rneb_dyn(klon,klev))
-      ALLOCATE(qclr(klon,klev), qcld(klon,klev), qss(klon,klev), qvc(klon,klev))
-      ALLOCATE(rnebclr(klon,klev), rnebss(klon,klev), gamma_ss(klon,klev))
-      ALLOCATE(N1_ss(klon,klev), N2_ss(klon,klev))
-      ALLOCATE(drneb_sub(klon,klev), drneb_con(klon,klev), drneb_tur(klon,klev), drneb_avi(klon,klev))
-      ALLOCATE(zqsatl(klon,klev), zqsats(klon,klev))
-      ALLOCATE(Tcontr(klon,klev), qcontr(klon,klev), qcontr2(klon,klev), fcontrN(klon,klev), fcontrP(klon,klev))
-
-!--POPRECIP variables
-      ALLOCATE(qraindiag(klon,klev), qsnowdiag(klon,klev))
-      ALLOCATE(dqreva(klon,klev), dqssub(klon,klev))
-      ALLOCATE(dqrauto(klon,klev), dqrcol(klon,klev), dqrmelt(klon,klev), dqrfreez(klon,klev))
-      ALLOCATE(dqsauto(klon,klev), dqsagg(klon,klev), dqsrim(klon,klev), dqsmelt(klon,klev), dqsfreez(klon,klev))
-
-#ifdef CPP_StratAer
-      ALLOCATE (d_q_emiss(klon,klev))
-      ALLOCATE (R2SO4(klon,klev))
-      ALLOCATE (DENSO4(klon,klev))
-      ALLOCATE (f_r_wet(klon,klev))
-      ALLOCATE (decfluxaer(klon,nbtr))
+    ALLOCATE (p_tropopause(klon))
+    ALLOCATE (z_tropopause(klon))
+    ALLOCATE (t_tropopause(klon))
+
+    ALLOCATE(zn2mout(klon, 6))
+
+    ! Supersaturation
+    ALLOCATE(rneb_seri(klon, klev))
+    ALLOCATE(d_rneb_dyn(klon, klev))
+    ALLOCATE(qclr(klon, klev), qcld(klon, klev), qss(klon, klev), qvc(klon, klev))
+    ALLOCATE(rnebclr(klon, klev), rnebss(klon, klev), gamma_ss(klon, klev))
+    ALLOCATE(N1_ss(klon, klev), N2_ss(klon, klev))
+    ALLOCATE(drneb_sub(klon, klev), drneb_con(klon, klev), drneb_tur(klon, klev), drneb_avi(klon, klev))
+    ALLOCATE(zqsatl(klon, klev), zqsats(klon, klev))
+    ALLOCATE(Tcontr(klon, klev), qcontr(klon, klev), qcontr2(klon, klev), fcontrN(klon, klev), fcontrP(klon, klev))
+
+    !--POPRECIP variables
+    ALLOCATE(qraindiag(klon, klev), qsnowdiag(klon, klev))
+    ALLOCATE(dqreva(klon, klev), dqssub(klon, klev))
+    ALLOCATE(dqrauto(klon, klev), dqrcol(klon, klev), dqrmelt(klon, klev), dqrfreez(klon, klev))
+    ALLOCATE(dqsauto(klon, klev), dqsagg(klon, klev), dqsrim(klon, klev), dqsmelt(klon, klev), dqsfreez(klon, klev))
+
+    IF (CPPKEY_STRATAER) THEN
+      ALLOCATE (d_q_emiss(klon, klev))
+      ALLOCATE (R2SO4(klon, klev))
+      ALLOCATE (DENSO4(klon, klev))
+      ALLOCATE (f_r_wet(klon, klev))
+      ALLOCATE (decfluxaer(klon, nbtr))
       ALLOCATE (mdw(nbtr))
-      ALLOCATE (budg_3D_nucl(klon,klev))
-      ALLOCATE (budg_3D_cond_evap(klon,klev))
-      ALLOCATE (budg_3D_ocs_to_so2(klon,klev))
-      ALLOCATE (budg_3D_so2_to_h2so4(klon,klev))
-      ALLOCATE (budg_3D_backgr_ocs(klon,klev))
-      ALLOCATE (budg_3D_backgr_so2(klon,klev))
-      ALLOCATE (OCS_lifetime(klon,klev))
-      ALLOCATE (SO2_lifetime(klon,klev))
-      ALLOCATE (H2SO4_lifetime(klon,klev))
-      ALLOCATE (O3_clim(klon,klev))
-      ALLOCATE (alpha_bin(nbands_sw_rrtm+nbands_lw_rrtm+nwave,nbtr))
-      ALLOCATE (piz_bin(nbands_sw_rrtm+nbands_lw_rrtm+nwave,nbtr))
-      ALLOCATE (cg_bin(nbands_sw_rrtm+nbands_lw_rrtm+nwave,nbtr))
-      ALLOCATE (tau_strat_550(klon,klev))
-      ALLOCATE (tau_strat_1020(klon,klev))
-      ALLOCATE (tausum_strat(klon,3))
+      ALLOCATE (budg_3D_nucl(klon, klev))
+      ALLOCATE (budg_3D_cond_evap(klon, klev))
+      ALLOCATE (budg_3D_ocs_to_so2(klon, klev))
+      ALLOCATE (budg_3D_so2_to_h2so4(klon, klev))
+      ALLOCATE (budg_3D_backgr_ocs(klon, klev))
+      ALLOCATE (budg_3D_backgr_so2(klon, klev))
+      ALLOCATE (OCS_lifetime(klon, klev))
+      ALLOCATE (SO2_lifetime(klon, klev))
+      ALLOCATE (H2SO4_lifetime(klon, klev))
+      ALLOCATE (O3_clim(klon, klev))
+      ALLOCATE (alpha_bin(nbands_sw_rrtm + nbands_lw_rrtm + nwave, nbtr))
+      ALLOCATE (piz_bin(nbands_sw_rrtm + nbands_lw_rrtm + nwave, nbtr))
+      ALLOCATE (cg_bin(nbands_sw_rrtm + nbands_lw_rrtm + nwave, nbtr))
+      ALLOCATE (tau_strat_550(klon, klev))
+      ALLOCATE (tau_strat_1020(klon, klev))
+      ALLOCATE (tausum_strat(klon, 3))
       ALLOCATE (budg_dep_dry_ocs(klon))
       ALLOCATE (budg_dep_wet_ocs(klon))
@@ -1244,49 +1247,49 @@
       ALLOCATE (budg_sed_part(klon))
       ALLOCATE (surf_PM25_sulf(klon))
-      ALLOCATE (vsed_aer(klon,klev))
-#endif
-
-END SUBROUTINE phys_local_var_init
-
-!======================================================================
-SUBROUTINE phys_local_var_end
-USE dimphy
-USE indice_sol_mod
-IMPLICIT NONE
-      DEALLOCATE(t_seri,q_seri,ql_seri,qs_seri, qbs_seri,qx_seri)
-      DEALLOCATE(u_seri,v_seri)
-      DEALLOCATE(l_mixmin,l_mix,wprime)
-      DEALLOCATE(tke_shear,tke_buoy,tke_trans)
-      DEALLOCATE(pbl_eps)
-      DEALLOCATE(rhcl)
-      DEALLOCATE(tr_seri)
-      DEALLOCATE(d_t_dyn,d_q_dyn)
-      DEALLOCATE(d_ql_dyn,d_qs_dyn, d_qbs_dyn)
-      DEALLOCATE(d_q_dyn2d,d_ql_dyn2d,d_qs_dyn2d, d_qbs_dyn2d)
-      DEALLOCATE(d_u_dyn,d_v_dyn)
-      DEALLOCATE(d_tr_dyn)                      !RomP
-      DEALLOCATE(d_t_con,d_q_con,d_q_con_zmasse)
-      DEALLOCATE(d_u_con,d_v_con)
-      DEALLOCATE(d_t_wake,d_q_wake)
-      DEALLOCATE(d_t_lsc,d_q_lsc)
-      DEALLOCATE(d_t_lwr,d_t_lw0)
-      DEALLOCATE(d_t_swr,d_t_sw0)
-      DEALLOCATE(d_ql_lsc,d_qi_lsc)
-      DEALLOCATE(d_t_ajsb,d_q_ajsb)
-      DEALLOCATE(d_t_ajs,d_q_ajs)
-!nrlmd<
-      DEALLOCATE(d_t_ajs_w,d_q_ajs_w)
-      DEALLOCATE(d_t_ajs_x,d_q_ajs_x)
-!>nrlmd
-      DEALLOCATE(d_u_ajs,d_v_ajs)
-      DEALLOCATE(d_t_eva,d_q_eva)
-      DEALLOCATE(d_qx_eva)
-      DEALLOCATE(d_ql_eva,d_qi_eva)
-      DEALLOCATE(d_t_lscst,d_q_lscst)
-      DEALLOCATE(d_t_lscth,d_q_lscth)
-      DEALLOCATE(plul_st,plul_th)
-      DEALLOCATE(d_t_vdf,d_q_vdf,d_t_diss)
-      DEALLOCATE(d_qbs_vdf)
-      DEALLOCATE(d_t_bsss,d_q_bsss,d_qbs_bsss)
+      ALLOCATE (vsed_aer(klon, klev))
+    END IF
+
+  END SUBROUTINE phys_local_var_init
+
+  !======================================================================
+  SUBROUTINE phys_local_var_end
+    USE dimphy
+    USE indice_sol_mod
+    IMPLICIT NONE
+    DEALLOCATE(t_seri, q_seri, ql_seri, qs_seri, qbs_seri, qx_seri)
+    DEALLOCATE(u_seri, v_seri)
+    DEALLOCATE(l_mixmin, l_mix, wprime)
+    DEALLOCATE(tke_shear, tke_buoy, tke_trans)
+    DEALLOCATE(pbl_eps)
+    DEALLOCATE(rhcl)
+    DEALLOCATE(tr_seri)
+    DEALLOCATE(d_t_dyn, d_q_dyn)
+    DEALLOCATE(d_ql_dyn, d_qs_dyn, d_qbs_dyn)
+    DEALLOCATE(d_q_dyn2d, d_ql_dyn2d, d_qs_dyn2d, d_qbs_dyn2d)
+    DEALLOCATE(d_u_dyn, d_v_dyn)
+    DEALLOCATE(d_tr_dyn)                      !RomP
+    DEALLOCATE(d_t_con, d_q_con, d_q_con_zmasse)
+    DEALLOCATE(d_u_con, d_v_con)
+    DEALLOCATE(d_t_wake, d_q_wake)
+    DEALLOCATE(d_t_lsc, d_q_lsc)
+    DEALLOCATE(d_t_lwr, d_t_lw0)
+    DEALLOCATE(d_t_swr, d_t_sw0)
+    DEALLOCATE(d_ql_lsc, d_qi_lsc)
+    DEALLOCATE(d_t_ajsb, d_q_ajsb)
+    DEALLOCATE(d_t_ajs, d_q_ajs)
+    !nrlmd<
+    DEALLOCATE(d_t_ajs_w, d_q_ajs_w)
+    DEALLOCATE(d_t_ajs_x, d_q_ajs_x)
+    !>nrlmd
+    DEALLOCATE(d_u_ajs, d_v_ajs)
+    DEALLOCATE(d_t_eva, d_q_eva)
+    DEALLOCATE(d_qx_eva)
+    DEALLOCATE(d_ql_eva, d_qi_eva)
+    DEALLOCATE(d_t_lscst, d_q_lscst)
+    DEALLOCATE(d_t_lscth, d_q_lscth)
+    DEALLOCATE(plul_st, plul_th)
+    DEALLOCATE(d_t_vdf, d_q_vdf, d_t_diss)
+    DEALLOCATE(d_qbs_vdf)
+    DEALLOCATE(d_t_bsss, d_q_bsss, d_qbs_bsss)
 #ifdef ISO
       deallocate(xt_seri,xtl_seri,xts_seri,xtbs_seri)
@@ -1311,109 +1314,109 @@
 #endif
 
-      DEALLOCATE(d_u_vdf,d_v_vdf)
-      DEALLOCATE(d_t_oli,d_t_oro)
-      DEALLOCATE(d_u_oli,d_v_oli)
-      DEALLOCATE(d_u_oro,d_v_oro)
-      DEALLOCATE(d_t_oro_gw)
-      DEALLOCATE(d_u_oro_gw,d_v_oro_gw)
-      DEALLOCATE(d_t_lif,d_t_ec)
-      DEALLOCATE(d_u_lif,d_v_lif)
-      DEALLOCATE(d_ts, d_tr)
-      DEALLOCATE(topswad_aero,solswad_aero)
-      DEALLOCATE(topswai_aero,solswai_aero)
-      DEALLOCATE(topswad0_aero,solswad0_aero)
-      DEALLOCATE(toplwad_aero,sollwad_aero)
-      DEALLOCATE(toplwai_aero,sollwai_aero)
-      DEALLOCATE(toplwad0_aero,sollwad0_aero)
-      DEALLOCATE(topsw_aero,solsw_aero)
-      DEALLOCATE(topsw0_aero,solsw0_aero)
-      DEALLOCATE(topswcf_aero,solswcf_aero)
-      DEALLOCATE(stratomask) 
-      DEALLOCATE(tausum_aero) 
-      DEALLOCATE(drytausum_aero) 
-      DEALLOCATE(tau3d_aero) 
-      DEALLOCATE(dNovrN)
-      DEALLOCATE(zfice)
-      DEALLOCATE(od443aer)
-      DEALLOCATE(od550aer)
-      DEALLOCATE(od865aer)
-      DEALLOCATE(dryod550aer)
-      DEALLOCATE(abs550aer)
-      DEALLOCATE(ec550aer)
-      DEALLOCATE(od550lt1aer)
-      DEALLOCATE(sconcso4) 
-      DEALLOCATE(sconcno3) 
-      DEALLOCATE(sconcoa) 
-      DEALLOCATE(sconcbc) 
-      DEALLOCATE(sconcss) 
-      DEALLOCATE(sconcdust) 
-      DEALLOCATE(concso4) 
-      DEALLOCATE(concno3) 
-      DEALLOCATE(concoa) 
-      DEALLOCATE(concbc) 
-      DEALLOCATE(concss) 
-      DEALLOCATE(concdust) 
-      DEALLOCATE(loadso4) 
-      DEALLOCATE(loadoa) 
-      DEALLOCATE(loadbc) 
-      DEALLOCATE(loadss) 
-      DEALLOCATE(loaddust) 
-      DEALLOCATE(loadno3) 
-      DEALLOCATE(load_tmp1)
-      DEALLOCATE(load_tmp2)
-      DEALLOCATE(load_tmp3)
-      DEALLOCATE(load_tmp4)
-      DEALLOCATE(load_tmp5)
-      DEALLOCATE(load_tmp6)
-      DEALLOCATE(load_tmp7)
-      DEALLOCATE(load_tmp8)
-      DEALLOCATE(load_tmp9)
-      DEALLOCATE(load_tmp10)
-      DEALLOCATE(du_gwd_hines,dv_gwd_hines,d_t_hin)
-      DEALLOCATE(d_q_ch4)
-      DEALLOCATE(dv_gwd_rando,dv_gwd_front)
-      DEALLOCATE(east_gwstress,west_gwstress)
-
-!IM ajout variables CFMIP2/CMIP5
-      DEALLOCATE(topswad_aerop, solswad_aerop)
-      DEALLOCATE(topswai_aerop, solswai_aerop)
-      DEALLOCATE(topswad0_aerop, solswad0_aerop)
-      DEALLOCATE(topsw_aerop, topsw0_aerop)
-      DEALLOCATE(solsw_aerop, solsw0_aerop)
-      DEALLOCATE(topswcf_aerop, solswcf_aerop)
-!AI Aerosols
-      DEALLOCATE(m_allaer)
-!CK LW diagnostics
-      DEALLOCATE(toplwad_aerop, sollwad_aerop)
-      DEALLOCATE(toplwai_aerop, sollwai_aerop)
-      DEALLOCATE(toplwad0_aerop, sollwad0_aerop)
-
-!AI Ajout pour Ecrad (3Deffect)
-      DEALLOCATE(topswad_aero_s2, solswad_aero_s2)
-      DEALLOCATE(topswai_aero_s2, solswai_aero_s2)
-      DEALLOCATE(topswad0_aero_s2, solswad0_aero_s2)
-      DEALLOCATE(topsw_aero_s2, topsw0_aero_s2)
-      DEALLOCATE(solsw_aero_s2, solsw0_aero_s2)
-      DEALLOCATE(topswcf_aero_s2, solswcf_aero_s2)
-!CK LW diagnostics
-      DEALLOCATE(toplwad_aero_s2, sollwad_aero_s2)
-      DEALLOCATE(toplwai_aero_s2, sollwai_aero_s2)
-      DEALLOCATE(toplwad0_aero_s2, sollwad0_aero_s2)      
-
-! FH Ajout de celles necessaires au phys_output_write_mod
-      DEALLOCATE(tal1, pal1, pab1, pab2)
-      DEALLOCATE(ptstar, pt0, slp)
-!
-      DEALLOCATE(alp_wake)
-      DEALLOCATE(wake_h,wake_k)
-      DEALLOCATE(wake_omg)
-      DEALLOCATE(d_deltat_wk, d_deltaq_wk)
-      DEALLOCATE(d_s_wk, d_dens_a_wk, d_dens_wk)
-      DEALLOCATE(d_deltat_wk_gw, d_deltaq_wk_gw)
-      DEALLOCATE(d_deltat_vdf, d_deltaq_vdf)
-!!      DEALLOCATE( d_s_vdf, d_dens_vdf)
-      DEALLOCATE(d_deltat_the, d_deltaq_the)
-!!      DEALLOCATE( d_s_the, d_dens_the)
-      DEALLOCATE(d_deltat_ajs_cv, d_deltaq_ajs_cv)
+    DEALLOCATE(d_u_vdf, d_v_vdf)
+    DEALLOCATE(d_t_oli, d_t_oro)
+    DEALLOCATE(d_u_oli, d_v_oli)
+    DEALLOCATE(d_u_oro, d_v_oro)
+    DEALLOCATE(d_t_oro_gw)
+    DEALLOCATE(d_u_oro_gw, d_v_oro_gw)
+    DEALLOCATE(d_t_lif, d_t_ec)
+    DEALLOCATE(d_u_lif, d_v_lif)
+    DEALLOCATE(d_ts, d_tr)
+    DEALLOCATE(topswad_aero, solswad_aero)
+    DEALLOCATE(topswai_aero, solswai_aero)
+    DEALLOCATE(topswad0_aero, solswad0_aero)
+    DEALLOCATE(toplwad_aero, sollwad_aero)
+    DEALLOCATE(toplwai_aero, sollwai_aero)
+    DEALLOCATE(toplwad0_aero, sollwad0_aero)
+    DEALLOCATE(topsw_aero, solsw_aero)
+    DEALLOCATE(topsw0_aero, solsw0_aero)
+    DEALLOCATE(topswcf_aero, solswcf_aero)
+    DEALLOCATE(stratomask)
+    DEALLOCATE(tausum_aero)
+    DEALLOCATE(drytausum_aero)
+    DEALLOCATE(tau3d_aero)
+    DEALLOCATE(dNovrN)
+    DEALLOCATE(zfice)
+    DEALLOCATE(od443aer)
+    DEALLOCATE(od550aer)
+    DEALLOCATE(od865aer)
+    DEALLOCATE(dryod550aer)
+    DEALLOCATE(abs550aer)
+    DEALLOCATE(ec550aer)
+    DEALLOCATE(od550lt1aer)
+    DEALLOCATE(sconcso4)
+    DEALLOCATE(sconcno3)
+    DEALLOCATE(sconcoa)
+    DEALLOCATE(sconcbc)
+    DEALLOCATE(sconcss)
+    DEALLOCATE(sconcdust)
+    DEALLOCATE(concso4)
+    DEALLOCATE(concno3)
+    DEALLOCATE(concoa)
+    DEALLOCATE(concbc)
+    DEALLOCATE(concss)
+    DEALLOCATE(concdust)
+    DEALLOCATE(loadso4)
+    DEALLOCATE(loadoa)
+    DEALLOCATE(loadbc)
+    DEALLOCATE(loadss)
+    DEALLOCATE(loaddust)
+    DEALLOCATE(loadno3)
+    DEALLOCATE(load_tmp1)
+    DEALLOCATE(load_tmp2)
+    DEALLOCATE(load_tmp3)
+    DEALLOCATE(load_tmp4)
+    DEALLOCATE(load_tmp5)
+    DEALLOCATE(load_tmp6)
+    DEALLOCATE(load_tmp7)
+    DEALLOCATE(load_tmp8)
+    DEALLOCATE(load_tmp9)
+    DEALLOCATE(load_tmp10)
+    DEALLOCATE(du_gwd_hines, dv_gwd_hines, d_t_hin)
+    DEALLOCATE(d_q_ch4)
+    DEALLOCATE(dv_gwd_rando, dv_gwd_front)
+    DEALLOCATE(east_gwstress, west_gwstress)
+
+    !IM ajout variables CFMIP2/CMIP5
+    DEALLOCATE(topswad_aerop, solswad_aerop)
+    DEALLOCATE(topswai_aerop, solswai_aerop)
+    DEALLOCATE(topswad0_aerop, solswad0_aerop)
+    DEALLOCATE(topsw_aerop, topsw0_aerop)
+    DEALLOCATE(solsw_aerop, solsw0_aerop)
+    DEALLOCATE(topswcf_aerop, solswcf_aerop)
+    !AI Aerosols
+    DEALLOCATE(m_allaer)
+    !CK LW diagnostics
+    DEALLOCATE(toplwad_aerop, sollwad_aerop)
+    DEALLOCATE(toplwai_aerop, sollwai_aerop)
+    DEALLOCATE(toplwad0_aerop, sollwad0_aerop)
+
+    !AI Ajout pour Ecrad (3Deffect)
+    DEALLOCATE(topswad_aero_s2, solswad_aero_s2)
+    DEALLOCATE(topswai_aero_s2, solswai_aero_s2)
+    DEALLOCATE(topswad0_aero_s2, solswad0_aero_s2)
+    DEALLOCATE(topsw_aero_s2, topsw0_aero_s2)
+    DEALLOCATE(solsw_aero_s2, solsw0_aero_s2)
+    DEALLOCATE(topswcf_aero_s2, solswcf_aero_s2)
+    !CK LW diagnostics
+    DEALLOCATE(toplwad_aero_s2, sollwad_aero_s2)
+    DEALLOCATE(toplwai_aero_s2, sollwai_aero_s2)
+    DEALLOCATE(toplwad0_aero_s2, sollwad0_aero_s2)
+
+    ! FH Ajout de celles necessaires au phys_output_write_mod
+    DEALLOCATE(tal1, pal1, pab1, pab2)
+    DEALLOCATE(ptstar, pt0, slp)
+    !
+    DEALLOCATE(alp_wake)
+    DEALLOCATE(wake_h, wake_k)
+    DEALLOCATE(wake_omg)
+    DEALLOCATE(d_deltat_wk, d_deltaq_wk)
+    DEALLOCATE(d_s_wk, d_dens_a_wk, d_dens_wk)
+    DEALLOCATE(d_deltat_wk_gw, d_deltaq_wk_gw)
+    DEALLOCATE(d_deltat_vdf, d_deltaq_vdf)
+    !!      DEALLOCATE( d_s_vdf, d_dens_vdf)
+    DEALLOCATE(d_deltat_the, d_deltaq_the)
+    !!      DEALLOCATE( d_s_the, d_dens_the)
+    DEALLOCATE(d_deltat_ajs_cv, d_deltaq_ajs_cv)
 #ifdef ISO
       DEALLOCATE(d_deltaxt_wk)
@@ -1422,43 +1425,43 @@
       DEALLOCATE(d_deltaxt_vdf)
 #endif
-!
-      DEALLOCATE(bils)
-      DEALLOCATE(cdragm, cdragh, cldh, cldl)
-      DEALLOCATE(cldm, cldq, cldt, qsat2m)
-      DEALLOCATE(JrNt)
-      DEALLOCATE(dthmin, evap, snowerosion, fder, plcl, plfc)
-      DEALLOCATE(prw, prlw, prsw, prbsw, water_budget, zustar, zu10m, zv10m, rh2m, s_lcl)
-      DEALLOCATE(s_pblh, s_pblt, s_therm)
-!
-!nrlmd+jyg<
-      DEALLOCATE(s_pblh_x, s_pblh_w)
-      DEALLOCATE(s_lcl_x, s_lcl_w)
-!>nrlmd+jyg
-!
-      DEALLOCATE(slab_wfbils, tpot, tpote, ue)
-      DEALLOCATE(uq, ve, vq, zxffonte)
-      DEALLOCATE(uwat, vwat)
-      DEALLOCATE(zxfqcalving, zxfluxlat)
-      DEALLOCATE(zxrunofflic)
-      DEALLOCATE(zxustartlic, zxrhoslic, zxqsaltlic)
-      DEALLOCATE(zxtsol, snow_lsc, zxfqfonte, zxqsurf)
-      DEALLOCATE(rain_lsc)
-      DEALLOCATE(rain_num)
-      DEALLOCATE(qlth, qith, qsith, wiceth)
-!
-      DEALLOCATE(sens_x, sens_w)
-      DEALLOCATE(zxfluxlat_x, zxfluxlat_w)
-      DEALLOCATE(delta_qsurf)
-!jyg<
-!!      DEALLOCATE(t_x, t_w)
-!!      DEALLOCATE(q_x, q_w)
-!>jyg
-      DEALLOCATE(d_t_vdf_x, d_t_vdf_w)
-      DEALLOCATE(d_q_vdf_x, d_q_vdf_w)
-      DEALLOCATE(pbl_tke_input)
-      DEALLOCATE(t_therm, q_therm, u_therm, v_therm)
-      DEALLOCATE(cdragh_x, cdragh_w)
-      DEALLOCATE(cdragm_x, cdragm_w)
-      DEALLOCATE(kh, kh_x, kh_w)
+    !
+    DEALLOCATE(bils)
+    DEALLOCATE(cdragm, cdragh, cldh, cldl)
+    DEALLOCATE(cldm, cldq, cldt, qsat2m)
+    DEALLOCATE(JrNt)
+    DEALLOCATE(dthmin, evap, snowerosion, fder, plcl, plfc)
+    DEALLOCATE(prw, prlw, prsw, prbsw, water_budget, zustar, zu10m, zv10m, rh2m, s_lcl)
+    DEALLOCATE(s_pblh, s_pblt, s_therm)
+    !
+    !nrlmd+jyg<
+    DEALLOCATE(s_pblh_x, s_pblh_w)
+    DEALLOCATE(s_lcl_x, s_lcl_w)
+    !>nrlmd+jyg
+    !
+    DEALLOCATE(slab_wfbils, tpot, tpote, ue)
+    DEALLOCATE(uq, ve, vq, zxffonte)
+    DEALLOCATE(uwat, vwat)
+    DEALLOCATE(zxfqcalving, zxfluxlat)
+    DEALLOCATE(zxrunofflic)
+    DEALLOCATE(zxustartlic, zxrhoslic, zxqsaltlic)
+    DEALLOCATE(zxtsol, snow_lsc, zxfqfonte, zxqsurf)
+    DEALLOCATE(rain_lsc)
+    DEALLOCATE(rain_num)
+    DEALLOCATE(qlth, qith, qsith, wiceth)
+    !
+    DEALLOCATE(sens_x, sens_w)
+    DEALLOCATE(zxfluxlat_x, zxfluxlat_w)
+    DEALLOCATE(delta_qsurf)
+    !jyg<
+    !!      DEALLOCATE(t_x, t_w)
+    !!      DEALLOCATE(q_x, q_w)
+    !>jyg
+    DEALLOCATE(d_t_vdf_x, d_t_vdf_w)
+    DEALLOCATE(d_q_vdf_x, d_q_vdf_w)
+    DEALLOCATE(pbl_tke_input)
+    DEALLOCATE(t_therm, q_therm, u_therm, v_therm)
+    DEALLOCATE(cdragh_x, cdragh_w)
+    DEALLOCATE(cdragm_x, cdragm_w)
+    DEALLOCATE(kh, kh_x, kh_w)
 #ifdef ISO
       DEALLOCATE(xtevap,xtprw)
